#!/usr/bin/env python3

"""Convert ntds.dit into JSON"""

import codecs
import datetime
import json
import re
import struct
import sys
import uuid
from textwrap import dedent
from typing import Any

import pandas as pd
import pyesedb
from ad_constants import ESENT_TO_LDAP_DECODED
from ldap3.protocol.formatters.formatters import format_ad_timestamp
from loguru import logger
from path import Path


def generate_esent_attr_map(orig_df: pd.DataFrame) -> dict:
    """Generate mapping from internal ESENT attributes to (relatively) human-readable LDAP attributes

    TODO: Generate description on demand?
    """

    esent_ldap_attr_name = "ATTm131532"
    esent_attr_id = "ATTc131102"

    df = orig_df.copy(deep=True)
    df = df.loc[(df[esent_ldap_attr_name].notna()) & (df[esent_attr_id].notna())]
    df = df[[esent_ldap_attr_name, esent_attr_id]]

    result = {}

    for row in df.iterrows():
        attr_name, attr_id = row[1][esent_ldap_attr_name], row[1][esent_attr_id]

        matches = [
            re.fullmatch(fr"ATT[a-z]{attr_id}", col)[0]
            for col in orig_df.columns.tolist()
            if re.fullmatch(fr"ATT[a-z]{attr_id}", col)
        ]

        if len(matches) == 1:
            logger.trace(f"Matched {attr_name} with {matches[0]}")
            result[matches[0]] = attr_name
        else:
            # logger.trace(f"Found {len(matches)} matches for {attr_name}. Skipping")
            pass

    return result


# Set up logging
LOG_FORMAT = (
    "<green>{time:YYYY-MM-DD HH:mm:ss}</green> | <level>{level: <8}</level> | <level>{message}</level>"
)

logger.remove()
logger.add(sys.stdout, format=LOG_FORMAT, level="DEBUG")
logger.configure(levels=[dict(name="DEBUG", color="<magenta><bold>")])  # type: ignore

# This is a TSV generated by esedbexport (shoutout to libesedb!)
# ! WARNING: 'dtype=object' will prevent automatic conversion of types, but will clobber them as well
logger.info("Reading in datatable...")
df = pd.read_csv("data/ntds.dit.export/datatable.4", sep="\t", encoding="utf-8", dtype=object)
df = df.reset_index()

# Dynamically rename columns from internal attribute IDs to LDAP attribute names
logger.info("Renaming columns...")
df = df.rename(columns=generate_esent_attr_map(df))

# Write some JSON
# TODO: Remove "index" field
logger.info("Converting DataFrame to dict...")
data = df.to_dict(orient="records")

logger.info("Fixing up types where possible...")
for row in data:
    for k, v in row.items():
        if isinstance(v, str) and v.isdigit():
            row[k] = int(v)

logger.info("Writing JSON...")
Path("data/ntds.dit.export/datatable.json").write_text(json.dumps(data, default=str, indent=2))

# Or to get only users:
# data = df.loc[df["userPrincipalName"].notnull()].to_dict(orient="records")
